import java.awt.*;
import java.awt.event.*;
import java.lang.*;

public class Text_io extends Panel implements Runnable{
 private tcpip gtp;
 String oldmessage = new String("");
 Thread timer;
 TextField MagsReading = new TextField("mags",40);
 TextField TemperatureReading = new TextField("Temperature");
 TextField FrequencyReading = new TextField("Frequency");
 TextField PeriodReading = new TextField("Period");
 TextField LightCalResp = new TextField("Arm LightCal");
 TextField LockedResp = new TextField("Locked/Unlocked");
 TextField DarkCalResp = new TextField("Arm DarkCal");
 TextField ModelResponse = new TextField("Firmware");
 TextField SerialResponse = new TextField("Model, Serial number");
 TextField CalLight = new TextField("Calibration light reading");
 TextField CalDark = new TextField("Calibration dark time");
 TextField CalLightTemp = new TextField("Light Calibration Temperature");
 TextField CalOffset = new TextField("Calibration Offset");
 TextField CalDarkTemp = new TextField("Dark Calibration Temperature");

 public Text_io(tcpip tp) {
 gtp = tp;

 setLayout(new GridBagLayout());
 GridBagConstraints c = new GridBagConstraints();

//  Dimension d = new Dimension(123, 456);
//  c.setMinimumSize(d);

 timer = new Thread(this);
 timer.start();

 // Add text fields, will be filled later by pushbutton responses
 c.anchor = GridBagConstraints.WEST;
 c.fill = GridBagConstraints.BOTH;
 c.gridx = 1; c.gridwidth = 1; c.gridheight = 1;
 c.gridy = 5; add(MagsReading, c);
 c.gridy = 6; add(FrequencyReading, c);
 c.gridy = 7; add(PeriodReading, c);
 c.gridy = 8; add(TemperatureReading, c);
 c.gridy = 9; add(LightCalResp, c);
 c.gridy = 10; add(DarkCalResp, c);
 c.gridy = 11; add(LockedResp, c);
 c.gridy = 13; add(ModelResponse, c);
 c.gridy = 14; add(SerialResponse, c);
 c.gridy = 15; add(CalLight, c);
 c.gridy = 16; add(CalDark, c);
 c.gridy = 17; add(CalLightTemp, c);
 c.gridy = 18; add(CalOffset, c);
 c.gridy = 19; add(CalDarkTemp, c);

 c.anchor = GridBagConstraints.EAST;
 c.gridx = 0; c.gridwidth = 1; c.gridheight = 1;

 c.gridy = 5;
 Button Magsbutton = new Button( "Reading" );
	Magsbutton.addActionListener( new ActionListener() {
		public void actionPerformed( ActionEvent e ){
			MagsReading.setText("");
			TemperatureReading.setText("");
			FrequencyReading.setText("");
			PeriodReading.setText("");
			gtp.send("rx");
// 			System.out.println(timer.isAlive());
		}
	} );
 add(Magsbutton, c);

 c.gridy = c.gridy+4;
 Button button4 = new Button( "Arm Light Calibration" );
	button4.addActionListener(
		new ActionListener(){
			public void actionPerformed( ActionEvent e ){
				LightCalResp.setText("");
				DarkCalResp.setText("");
				gtp.send("zcalAx");
			}
		}
	);
 add(button4, c);

 c.gridy = c.gridy+1;
 Button button5 = new Button( "Arm Dark Calibration" );
	button5.addActionListener(
		new ActionListener(){
			public void actionPerformed( ActionEvent e ){
				gtp.send("zcalBx");
				LightCalResp.setText("");
				DarkCalResp.setText("");
			}
		}
	);
 add(button5, c);

 c.gridy = c.gridy+1;
 Button DisArmButton = new Button( "Disarm Calibration" );
	DisArmButton.addActionListener(
		new ActionListener(){
			public void actionPerformed( ActionEvent e ){
				gtp.send("zcalDx");
				LightCalResp.setText("");
				DarkCalResp.setText("");
			}
		}
	);
 add(DisArmButton, c);

 c.gridy = c.gridy+2;
 Button button6 = new Button( "Unit Info" );
    button6.addActionListener( new ActionListener(){
	public void actionPerformed( ActionEvent e ){
		ModelResponse.setText("");
		SerialResponse.setText("");
		gtp.send("ix");}
	} );
 add(button6, c);

 c.gridy = c.gridy+2;
 Button CalInfoButton = new Button( "Calibration Info" );
	CalInfoButton.addActionListener( new ActionListener() {
		public void actionPerformed( ActionEvent e ){
			CalLight.setText("");
			CalDark.setText("");
			CalLightTemp.setText("");
			CalOffset.setText("");
			CalDarkTemp.setText("");
			gtp.send("cx");
		}
	} );
 add(CalInfoButton, c);

 c.gridy = c.gridy+1;
 Button ResetButton = new Button( "Reset Unit" );
	ResetButton.addActionListener( new ActionListener() {
		public void actionPerformed( ActionEvent e ){
// 			gtp.send(0x09);
			gtp.send("xx");
		}
	} );
//  add(ResetButton, c);


}

 public void run() {
 int i, LFPos;
 byte[] in;
 String buffstring="";
 String cmdstring="";
 while (true) {
 try { Thread.currentThread().sleep(200); }
 catch (InterruptedException e) { }
 if ( (gtp != null) && ((i = gtp.available()) > 0) ) {

String instring = new String(gtp.receive());

//*** Pull out one response from string and process it.
buffstring += instring;
LFPos = buffstring.indexOf(0x0a);
cmdstring = buffstring.substring(0,LFPos+1);
buffstring = buffstring.substring(LFPos+1,buffstring.length());

// System.out.println("LF=");
// System.out.println(LFPos);
// System.out.println("cmdstring = " + cmdstring);
// System.out.println("buffstring = " + buffstring);


while (cmdstring.length()>0){ // process all available commands
// System.out.println(cmdstring);

if (cmdstring.startsWith("r")){ //Mags reading
	String sMags,sFrequency,sPeriod,sTemperature;
// 	System.out.println(cmdstring);
	if (cmdstring.length()>53) {	//perform validity check for length of string
		sMags=cmdstring.substring(2,9);
		MagsReading.setText(sMags);
		sFrequency=cmdstring.substring(10,22);
		FrequencyReading.setText(sFrequency);
		sPeriod=cmdstring.substring(23,47);
		PeriodReading.setText(sPeriod);
		sTemperature=cmdstring.substring(48,55);
		TemperatureReading.setText(sTemperature);
	}
}

if (cmdstring.startsWith("i")){ //Unit Info (Model, Serial)
	String sModel, sSerial;
// 	System.out.println(cmdstring);
	int iFirstChar=cmdstring.indexOf(",")+1;
	int iLastChar=cmdstring.indexOf(",",cmdstring.indexOf(",")+1);
	if (iFirstChar<iLastChar) {
		ModelResponse.setText("Protocol="+cmdstring.substring(2,10) +", Feature="+cmdstring.substring(20,28));
		SerialResponse.setText("Model="+cmdstring.substring(11,19)+", Serial = " + cmdstring.substring(29,37));
	}
}

if (cmdstring.startsWith("zA")){ //Light Calibration response
	if (cmdstring.startsWith("zAa")){LightCalResp.setText("Armed");}
	if (cmdstring.contains("L")) LockedResp.setText("Locked"); else LockedResp.setText("Unlocked");
}

if (cmdstring.startsWith("zB")){ //Dark Calibration response
	if (cmdstring.startsWith("zBa")){DarkCalResp.setText("Armed");}
	if (cmdstring.contains("L")) LockedResp.setText("Locked"); else LockedResp.setText("Unlocked");
}

if (cmdstring.startsWith("zxd")){ //Dark Calibration response
	LightCalResp.setText("Disarmed");
	DarkCalResp.setText("Disarmed");
	if (cmdstring.contains("L")) LockedResp.setText("Locked"); else LockedResp.setText("Unlocked");
}

if (cmdstring.startsWith("c")){ //Calibration information
	String sCalLight,sCalDark,sCalLightTemp,sCalOffset,sCalDarkTemp;
// 	System.out.println(cmdstring);
	if (cmdstring.length()>48) {	//perform validity check for length of string
		sCalLight=cmdstring.substring(2,14);
		CalLight.setText(sCalLight);
		sCalDark=cmdstring.substring(15,27);
		CalDark.setText(sCalDark);
		sCalLightTemp=cmdstring.substring(28,35);
		CalLightTemp.setText("Light Cal Temp = " + sCalLightTemp);
		sCalOffset=cmdstring.substring(36,48);
		CalOffset.setText(sCalOffset);
		sCalDarkTemp=cmdstring.substring(49,56);
		CalDarkTemp.setText("Dark Cal Temp = " + sCalDarkTemp);
	} else {
	 	System.out.println("Error: Calibration tring too short!");
	}
}


	LFPos = buffstring.indexOf(0x0a);
	cmdstring = buffstring.substring(0,LFPos+1);
	buffstring = buffstring.substring(LFPos+1,buffstring.length());


 }

}

 }
 }

}

